# Contributing
We use a modified kanban methodology called SOSASA (Structuring your project for the purposes Of Social Activism and Accessibility) for contributions. You can read about [our adaptation of SOSASA here (link)](sosasa-kanban.md), and creator hoodie aida kitten's complete onboarding article and [detailed SOSASA description here (link)](https://medium.com/@novemberninerniner/the-lifetime-of-an-issue-feature-request-f0ae1210e8c2).

If you'd like to contribute, welcome!! We are so glad you are here. We hope you will take a moment to read our [code of conduct (link)](code-of-conduct.md) before continuing.

To contribute, please read [our adaptation of SOSASA here (link)](sosasa-kanban.md), which contains more detail about how you can contribute, then join our [kanban boards (link)](https://kanban.lollipopcloud.solutions/) by signing up for an account and logging in.

* For documentation contributions, we have a [kanban board for documentation (link)](https://kanban.lollipopcloud.solutions/project/admin-lollipop-documentation/kanban/).

* For code-related contributions, we have a [kanban board for code (link)](https://kanban.lollipopcloud.solutions/project/admin-lollipop-cloud/kanban/)

...to read and comment on anything you see, or create a new issue by clicking the `+` sign at the top of the `Brainstorming` column.

If you already have code or documentation to contribute, our [documentation repository is here (link)](https://git.lollipopcloud.solutions/lollipop-cloud/docs) and our [code repo is here (link)](https://git.lollipopcloud.solutions/lollipop-cloud/lolipop_lan_cloud).

Lowering the barrier for contributions is important: we value your input, regardless of your level of experience or area of expertise. If you would rather [contact us directly (link)](https://lollipopcloud.solutions/page/contact/), please do not hesitate to reach out through email or chat. We can also provide assistance walking you through our contribution process if you'd like to learn SOSASA or Gitea.

Note: by submitting a PR, you agree to your contribution(s) being licensed as described in our [LICENSE.md (link)](LICENSE.md).

## Documentation

**In order to ease up the process of reading and applying docs, please:**

*   Add an intro to what the documentation is about (a couple of paragraphs should suffice) before presenting links, code, etc., for the sake of context - especially to the non-initiated;
*   Make very clear what each step is and use language that anyone would understand (KISS);
*   Don't abbreviate or assume something is banal/easy/common knowledge;
*   Be specific even when it sounds like it's something everyone knows about.
    Example of something that should be specified in docs: where to implement the stuff you just wrote about;

**For extra readability purposes:**

*   Use markdown, if possible, for different areas/topics among the doc (text vs code, for example), as well as space;
*   Break apart config/commands from docs.
*   If you can't explain a "basic concept" in a easy way without making a wall of text in the middle of your doc, feel free to hyperlink to other documentation where those concepts are already explained, be it Wikipedia or another doc online that has high readability and reliability;
